#if 0

x64/RedHat gcc 4.8.5

gcc -Wall -pipe -O3 -s -o FILEStructureTest_linux FILEStructureTest.c
gcc -Wall -pipe -O0 -g -o FILEStructureTest_linux FILEStructureTest.c

$ ./FILEStructureTest_linux FILEStructureTest.c
sizeof( FILE ) = 216
OFFSETOF( FILE*, _flags ) = 0

Visual Studio 2019 

cl.exe FILEStructureTest.c /FeFILEStructureTest_windows.exe /Zi /FdFILEStructureTest_windows.pdb /nologo /Os /Gs65536 /W4 /WX /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /link /machine:x64 /pdbaltpath:FILEStructureTest_windows.pdb /RELEASE /opt:ref
editbin.exe /dynamicbase:no FILEStructureTest_windows.exe

"/pdbaltpath"link.exeĲʹý.exeе.pdbָֻ֣ȱ
ʡľ·Ϣй¶

editbin.exeֹFILEStructureTest_windows.exeASLRڵԡ

$ FILEStructureTest_windows.exe FILEStructureTest.c
sizeof( FILE ) = 8
OFFSETOF( FILE*, _Placeholder ) = 0

#endif

/*
 * VS 2019fopen()İȫ
 */
#define _CRT_SECURE_NO_WARNINGS

#include <stdio.h>
#include <stdlib.h>

#define OFFSETOF(TYPE, MEMBER)  ((size_t)&((TYPE)0)->MEMBER)
#define BLOCKSIZE               32768

static void hexdump
(
    FILE           *out,
    unsigned char  *in,
    size_t          insize,
    size_t          count,
    size_t          offset
)
{
    size_t          k, j, i;

    if ( insize <= 0 || count <= 0 || NULL == in || NULL == out )
    {
        return;
    }
    i       = 0;
    for ( k = insize / count; k > 0; k--, offset += count )
    {
        fprintf( out, "%016zx:", offset );
        for ( j = 0; j < count; j++, i++ )
        {
            fprintf( out, " %02x", in[i] );
        }
        fprintf( out, "  " );
        i  -= count;
        for ( j = 0; j < count; j++, i++ )
        {
            if ( ( in[i] >= ' ' ) && ( in[i] < 0x7f ) )
            {
                fprintf( out, "%c", in[i] );
            }
            else
            {
                fprintf( out, "." );
            }
        }
        fprintf( out, "\n" );
    }  /* end of for */
    k       = insize - i;
    if ( k <= 0 )
    {
        return;
    }
    fprintf( out, "%016zx:", offset );
    for ( j = 0 ; j < k; j++, i++ )
    {
        fprintf( out, " %02x", in[i] );
    }
    i      -= k;
    for ( j = count - k; j > 0; j-- )
    {
        fprintf( out, "   " );
    }
    fprintf( out, "  " );
    for ( j = 0; j < k; j++, i++ )
    {
        if ( ( in[i] >= ' ' ) && ( in[i] < 0x7f ) )
        {
            fprintf( out, "%c", in[i] );
        }
        else
        {
            fprintf( out, "." );
        }
    }
    fprintf( out, "\n" );
    return;
}  /* end of hexdump */

#ifdef WIN32
#pragma warning( push )
#pragma warning( disable : 4100 )
#endif

/*
 * VS 2019¸澯
 *
 * FILEStructureTest.c(num): warning C4100: 'argc': unreferenced formal parameter
 *
 * ۽ԣδְȫ
 */
int main ( int argc, char * argv[] )
{
    char           *filename    = argv[1];
    FILE           *stream      = fopen( filename, "rb" );
    size_t          sum;
    unsigned char  *buffer      = malloc( BLOCKSIZE + 72 );
    size_t          offset      = 0;

    while ( 1 )
    {
        size_t  n;

        sum     = 0;
        while ( 1 )
        {
            n       = fread( buffer + sum, 1, BLOCKSIZE - sum, stream );
            sum    += n;
            if ( sum == BLOCKSIZE )
                break;
            if ( n == 0 )
            {
                if ( ferror( stream ) )
                {
                    free( buffer );
                    return 1;
                }
                goto process_partial_block;
            }
            if ( feof( stream ) )
                goto process_partial_block;
        }
        hexdump( stdout, buffer, BLOCKSIZE, 16, offset );
        offset += BLOCKSIZE;
    }

process_partial_block:

    if ( sum > 0 )
        hexdump( stdout, buffer, sum, 16, offset );
    free( buffer );
    fclose( stream );

#ifdef WIN32
    /*
     * C:\Program Files (x86)\Windows Kits\10\Include\10.0.18362.0\ucrt\corecrt_wstdio.h
     * C:\Program Files (x86)\Windows Kits\10\Include\10.0.18362.0\ucrt\mbstring.h
     */
    printf( "sizeof( FILE ) = %zu\n", sizeof( FILE ) );
    printf( "OFFSETOF( FILE*, _Placeholder ) = %zu\n", OFFSETOF( FILE*, _Placeholder ) );
#else
    /*
     * /usr/include/libio.h
     */
    printf( "sizeof( FILE ) = %zu\n", sizeof( FILE ) );
    printf( "OFFSETOF( FILE*, _flags ) = %zu\n", OFFSETOF( FILE*, _flags ) );
#endif

    return 0;
}

#ifdef WIN32
#pragma warning( pop )
#endif